//============================================================================
// ʒ`wb_
//
// (c)2023 Maikon-Giken
//============================================================================
#ifndef COMMON_H
#define	COMMON_H

//============================================================================
// `.
//============================================================================
// ^`.
typedef	unsigned char	uchar;
typedef	signed char		schar;
typedef	unsigned short	ushort;
typedef	unsigned int	uint;
typedef	unsigned long	ulong;
typedef	unsigned long long ulonglong;

//----------------------------------------------------------------------------
// l`
#ifndef FALSE
#define FALSE	(0)
#endif

#ifndef TRUE
#define TRUE	(1)
#endif

#ifndef EOF
#define EOF		(-1)
#endif

#ifndef NULL
#define NULL	(0)
#endif

//============================================================================
// API֐
//============================================================================
// CPU
//void __EI(void)	// ݋(CCRHgݍ݊֐)
//void __DI(void)	// ݋֎~(CCRHgݍ݊֐)
//void __halt()		// vZbT~(CCRHgݍ݊֐)
//void __nop(void)	// PTCN(CCRHgݍ݊֐)

//============================================================================
// ی쏑݃}N
//============================================================================
#define PROTECT_WORD	(0x000000A5UL)		// ݃veNgl
#define _protected_write(reg, value)	\
		(WPROTR.PROTCMD0 = PROTECT_WORD,\
		 reg = value, reg = (uint)~value, reg = value)	// veNg
#define _PROTECT_WRITE(preg, reg, value) \
		(preg = PROTECT_WORD,\
		 reg = value, reg = (uint)~value, reg = value)	// veNg
//============================================================================
// |[gWX^}N
//============================================================================
typedef volatile struct
{
    uchar b00:1;
    uchar b01:1;
    uchar b02:1;
    uchar b03:1;
    uchar b04:1;
    uchar b05:1;
    uchar b06:1;
    uchar b07:1;
    uchar b08:1;
    uchar b09:1;
    uchar b10:1;
    uchar b11:1;
    uchar b12:1;
    uchar b13:1;
    uchar b14:1;
    uchar b15:1;
} __PINF16;

#define _PIN(port, bit) 	(((__PINF16*)&(port))->##bit)		// s\̃oƂĈ߂Ɏgp

#define PORT_MODE_OUT	(0)		//|[g[h(o͕w)
#define PORT_MODE_IN	(1)
#define PORT_INBUFF_DIS	(0)		//|[g̓obt@
#define PORT_INBUFF_EN	(1)
#define PORT_PU_DIS		(0)		//|[g̓vAbv
#define PORT_PU_EN		(1)


//============================================================================
// Ӌ@\WX^}N
//============================================================================
typedef volatile struct
{
    uchar b00:1;
    uchar b01:1;
    uchar b02:1;
    uchar b03:1;
    uchar b04:1;
    uchar b05:1;
    uchar b06:1;
    uchar b07:1;
    uchar b08:1;
    uchar b09:1;
    uchar b10:1;
    uchar b11:1;
    uchar b12:1;
    uchar b13:1;
    uchar b14:1;
    uchar b15:1;
    uchar b16:1;
    uchar b17:1;
    uchar b18:1;
    uchar b19:1;
    uchar b20:1;
    uchar b21:1;
    uchar b22:1;
    uchar b23:1;
    uchar b24:1;
    uchar b25:1;
    uchar b26:1;
    uchar b27:1;
    uchar b28:1;
    uchar b29:1;
    uchar b30:1;
    uchar b31:1;
} __REGF32;

#define _REG(reg, bit) 	(((__REGF32*)&(reg))->##bit)		// \̃oiodefineŒ`ĂȂƂɎgp

//============================================================================
// ݑ
//============================================================================
typedef volatile struct
{
    uchar PRI:4;
    uchar :2;
    uchar TB:1;
    uchar MK:1;
    uchar :4;
    uchar RF:1;
    uchar :2;
    uchar CT:1;
} __ICREG;

#define NVIC_set_irq(ic)		(((__ICREG*)&(ic))->RF = 1)		//ݗvs
#define NVIC_clr_irq(ic)		(((__ICREG*)&(ic))->RF = 0)		//ݗv
#define NVIC_check_irq(ic)		(((__ICREG*)&(ic))->RF)			//ݗvQƂ
#define NVIC_enable_irq(ic)		(((__ICREG*)&(ic))->MK = 0)		//݋
#define NVIC_disable_irq(ic)	(((__ICREG*)&(ic))->MK = 1)		//݋Ȃ
#define NVIC_enable_check(ic)	(((__ICREG*)&(ic))->MK)			//݋ԎQ
#define NVIC_set_priority(ic, p) (((__ICREG*)&(ic))->PRI = p)	//ݗDxݒ肷B
#define NVIC_set_vector(ic,ch,func)	(DEVICE_set_vector((__ICREG*)&(ic), ch, (void*)func))	//݃e[uo^
#define NVIC_chg_vector(ch,func)	(DEVICE_chg_vector(ch, (void*)func))					//݃e[uύX

//------------------------------------------------------------------
//------------------------------------------------------------------

//============================================================================
#endif	/* COMMON_H */
