//============================================================================
// I2Cwb_(EEPANZXt)
//
// (c)2023 Maikon-Giken
//============================================================================
#ifndef TASK_I2C_H
#define	TASK_I2C_H

//============================================================================
// `.
//============================================================================
enum I2C_STATUS{
	I2C_STATUS_INIT,		// .
	I2C_STATUS_READY,		// ok(OAPI).
	I2C_STATUS_WRITE,		// writeR}hs.
	I2C_STATUS_READ,		// readR}hs.
	I2C_STATUS_REFUSE,		// APIsɂ󂯕t.
	I2C_STATUS_ACCEPT,		// API󂯕t.
	I2C_STATUS_WERROR,		// ݃G[.
	I2C_EEP_WRITE,			// EEPROM݃R}hs.
	I2C_EEP_READ,			// EEPROM݃R}hs.
	I2C_STATUS_ERROR,		// ̑I2CG[(G[ݔ)
};

//============================================================================
// API֐.
//============================================================================
void I2C_init(void);		// ^XN.
//		F.
//		ߒlF.

//---------------------------------------------------------------------
int I2C_write(int addr, char *buff, int num, schar* flag);		// ėpf[^݊Jn.
//		Fint addr		I2CAhX(7bit).
//		Fchar *buff	݃f[^ւ̃|C^.
//		Fint num		݃oCg.
//		Fschar* flag	t[NAAEOF݁BNULLw莞͉ȂB
//		ߒlFI2C_STATUS

//---------------------------------------------------------------------
int I2C_read(int addr, char *buff, int num, schar* flag);		// ėpf[^ǏoJn.
//		Fint addr		I2CAhX(7bit).
//		Fchar *buff	Ǐof[^̊i[|C^.
//		Fint num		ǏooCg.
//		Fschar* flag	t[NAAEOF݁BNULLw莞͉ȂB
//		ߒlFI2C_STATUS

//---------------------------------------------------------------------
int I2C_status(void);		// R}h̊mF.
//		F.
//		ߒlFI2C_STATUS

//---------------------------------------------------------------------
int I2C_EEP_write(int addr, char *buff, int num, schar* flag);		// EEPROMf[^݊Jn.
//		Fint addr		݊JnAhX.
//		Fchar *buff	݃f[^ւ̃|C^.
//		Fint num		݃oCg.
//		Fschar* flag	t[NAAEOF݁BNULLw莞͉ȂB
//		ߒlFI2C_STATUS

//---------------------------------------------------------------------
int I2C_EEP_read(int addr, char *buff, int num, schar* flag);		// EEPROMf[^݊Jn.
//		Fint addr		ǏoJnAhX.
//		Fchar *buff	Ǐof[^̊i[|C^.
//		Fint num		ǏooCg.
//		Fschar* flag	t[NAAEOF݁BNULLw莞͉ȂB
//		ߒlFI2C_STATUS

//============================================================================
#endif	/* TASK_I2C_H */
