;//============================================================================
;// u[gAbv@iCPUWX^ACϐj
;//
;// (c)2023 Maikon-Giken
;//============================================================================
;
; X^bNTCY(512oCgP)
STACKSIZE	.set	0x1000
;
;--------------------------------------------------------------------------------

;-----------------------------------------------------------------------------
;	ݏiڕj
;-----------------------------------------------------------------------------
	.section "RESET", text
	.align	512
	jr32	__reset	; RESET

	.align	16
	syncp
_Dummy0:
	jr	_Dummy0 ; SYSERR

	.align	16
_Dummy1:
	jr	_Dummy1	; *RFU*

	.align	16
_Dummy2:
	jr	_Dummy2 ; FETRAP

	.align	16
_Dummy_EIT0:
	jr	_Dummy_EIT0 ; TRAP0

	.align	16
_Dummy_EIT1:
	jr	_Dummy_EIT1 ; TRAP1

	.align	16
_Dummy3:
	jr	_Dummy3 ; RIE

	.align	16
	syncp
_Dummy_EIT3:
	jr	_Dummy_EIT3 ; FPP/FPI

	.align	16
_Dummy4:
	jr	_Dummy4 ; UCPOP

	.align	16
_Dummy5:
	jr	_Dummy5 ; MIP/MDP

	.align	16
_Dummy6:
	jr	_Dummy6 ; PIE

	.align	16
_Dummy7:
	jr	_Dummy7	; Debug

	.align	16
_Dummy8:
	jr	_Dummy8 ; MAE

	.align	16
_Dummy9:
	jr	_Dummy9	; *RFU*

	.align	16
	syncp
_Dummy10:
	jr	_Dummy10 ; FENMI

	.align	16
	syncp
_Dummy11:
	jr	_Dummy11 ; FEINT

	.align	16
	syncp
_Dummy_EIP0:
	jr	_Dummy_EIP0 ; INTn(priority0)

	.align	16
	syncp
_Dummy_EIP1:
	jr	_Dummy_EIP1 ; INTn(priority1)

	.align	16
	syncp
_Dummy_EIP2:
	jr	_Dummy_EIP2 ; INTn(priority2)

	.align	16
	syncp
_Dummy_EIP3:
	jr	_Dummy_EIP3 ; INTn(priority3)

	.align	16
	syncp
_Dummy_EIP4:
	jr	_Dummy_EIP4 ; INTn(priority4)

	.align	16
	syncp
_Dummy_EIP5:
	jr	_Dummy_EIP5 ; INTn(priority5)

	.align	16
	syncp
_Dummy_EIP6:
	jr	_Dummy_EIP6 ; INTn(priority6)

	.align	16
	syncp
_Dummy_EIP7:
	jr	_Dummy_EIP7 ; INTn(priority7)

	.align	16
	syncp
_Dummy_EIP8:
	jr	_Dummy_EIP8 ; INTn(priority8)

	.align	16
	syncp
_Dummy_EIP9:
	jr	_Dummy_EIP9 ; INTn(priority9)

	.align	16
	syncp
_Dummy_EIP10:
	jr	_Dummy_EIP10 ; INTn(priority10)

	.align	16
	syncp
_Dummy_EIP11:
	jr	_Dummy_EIP11 ; INTn(priority11)

	.align	16
	syncp
_Dummy_EIP12:
	jr	_Dummy_EIP12 ; INTn(priority12)

	.align	16
	syncp
_Dummy_EIP13:
	jr	_Dummy_EIP13 ; INTn(priority13)

	.align	16
	syncp
_Dummy_EIP14:
	jr	_Dummy_EIP14 ; INTn(priority14)

	.align	16
	syncp
_Dummy_EIP15:
	jr	_Dummy_EIP15 ; INTn(priority15)


;-----------------------------------------------------------------------------
;-----------------------------------------------------------------------------
;	ZbgX^[g
;-----------------------------------------------------------------------------
;-----------------------------------------------------------------------------
	.cseg	TEXT
__reset:
	mov	#_stacktop, sp			; X^bN|C^ݒ
	mov	#__ep_data, ep			; EPݒ(.ebss, .edata, .edata23, .ebss23ZNVp)
	mov	#__gp_data, gp			; GPݒ(.sbss, .sdata, .sdata23, .sbss23ZNVp)

;-----------------------------------------------------------------------------
;	Cϐ
;-----------------------------------------------------------------------------
	mov		#sINIT_DSEC, r6
	mov		#eINIT_DSEC, r7
	mov		#sINIT_BSEC, r8
	mov		#eINIT_BSEC, r9
	jarl32	__INITSCT_RH, lp	; RAM(CC-RHgݍ݊֐)

;-----------------------------------------------------------------------------
;	main֐̌ĂяoO(foCXA^XNAJ[l)
;-----------------------------------------------------------------------------
	jarl32	_INIT_init, lp		; init.c Q

;-----------------------------------------------------------------------------
;	main֐̌Ăяo
;-----------------------------------------------------------------------------
	jarl32	_main, lp			; main.c Q
_exit:
	br	_exit


;-----------------------------------------------------------------------------
;-----------------------------------------------------------------------------
;	eZNV̗̈ݒ
;-----------------------------------------------------------------------------
;-----------------------------------------------------------------------------

;-----------------------------------------------------------------------------
;	X^bN
;-----------------------------------------------------------------------------
	.section	".stack.bss", bss
	.public		_stackend
	.public		_stackchk
	.public		_stacktop
	.align	4
_stackend:
	.ds	(STACKSIZE - 128)
_stackchk:
	.ds	128
	.align	4
_stacktop:

;-----------------------------------------------------------------------------
;	ZNVe[u
;-----------------------------------------------------------------------------
	.cseg	const
	.align	4
sINIT_DSEC:
	.dw	#__s.data,		#__e.data,		#__s.data.R
	.dw	#__s.edata,		#__e.edata,		#__s.edata.R
$ifdef USE_ALL_SECTION
	.dw	#__s.edata23,	#__e.edata23,	#__s.edata23.R
	.dw	#__s.sdata,		#__e.sdata,		#__s.sdata.R
	.dw	#__s.sdata23,	#__e.sdata23,	#__s.sdata23.R
$endif
eINIT_DSEC:

sINIT_BSEC:
	.dw	#__s.bss,		#__e.bss
	.dw	#__s.ebss,		#__e.ebss
$ifdef USE_ALL_SECTION
	.dw	#__s.ebss23,	#__e.ebss23
	.dw	#__s.sbss,		#__e.sbss
	.dw	#__s.sbss23,	#__e.sbss23
$endif
eINIT_BSEC:

;-----------------------------------------------------------------------------
;	ZNV`(_~[)
;-----------------------------------------------------------------------------
	.cseg	TEXT
.L.dummy.text:

	.dseg	data
.L.dummy.data:

	.dseg	EDATA
.L.dummy.edata:

	.dseg	bss
.L.dummy.bss:

	.dseg	EBSS
.L.dummy.ebss:

	.cseg	const
.L.dummy.const:

	.cseg	ZCONST
.L.dummy.zconst:

$ifdef USE_ALL_SECTION
	.dseg	EDATA23
.L.dummy.edata23:

	.dseg	SDATA
.L.dummy.sdata:

	.dseg	SDATA23
.L.dummy.sdata23:

	.dseg	EBSS23
.L.dummy.ebss23:

	.dseg	SBSS
.L.dummy.sbss:

	.dseg	SBSS23
.L.dummy.sbss23:

	.cseg	ZCONST23
.L.dummy.zconst23:
$endif

;-----------------------------------------------------------------------------
