//============================================================================
// AiOM̓^XN
//
// (c)2023 Maikon-Giken
//============================================================================
#include "kernel.h"
#include "task_ad.h"

//============================================================================
// `.
//============================================================================
enum AD_STATUS {
	AD_STATUS_IDLE,
	AD_STATUS_BUSY,
	AD_STATUS_READY,
};

//============================================================================
// vg^Cv.
//============================================================================
void AD_main(void);						// AD^XN(又).

//============================================================================
// f[^.
//============================================================================
static volatile int AD_flag;								//ԃtO.
static volatile int AD_cnt;									//ړσJE^.
static volatile uint AD_in_data[AD_NUMBER][AD_AVENUM];
static volatile uint AD_out_data[AD_NUMBER];

//============================================================================
// API֐.
//============================================================================
// hCo[`
void AD_init(void) {
	// z`lݒiAD_CHANNEL_INDEX̏AD_CHANNEL_FCݒj
	ADCA0.VCR00.UINT32 = AD_FC_VOLM1;
	ADCA0.VCR01.UINT32 = AD_FC_VOLM2;
	ADCA0.VCR02.UINT32 = AD_FC_AUX1;
	ADCA0.VCR03.UINT32 = AD_FC_AUX2;
	ADCA0.VCR04.UINT32 = AD_FC_AUX3;
	ADCA0.VCR05.UINT32 = AD_FC_AUX4;
	
	//ݒ
	//ADCA0.ADCR.UINT32 = 0;				//default
	if (ADC_FREQUENCY > 32000000)	ADCA0.SMPCR.UINT32 = 18;
	else							ADCA0.SMPCR.UINT32 = 24;
	//ADCA0.SGCR1.UINT32 = 0;				//default
	ADCA0.SGVCSP1.UINT32 = 0;				//XLJn_CH
	ADCA0.SGVCEP1.UINT32 = AD_NUMBER - 1;	//XLI_CH
	//ADCA0.SGMCYCR1.UINT32 = 0;			//default

	//^XNN
	start_task(AD_taskid, AD_main);
}

//---------------------------------------------------------------------
// AiO͒l擾.
uint AD_value(uint ch) {
	if (AD_flag == AD_STATUS_READY && ch < AD_NUMBER) {
		return AD_out_data[ch];
	}
	return 0;
}

//============================================================================
// ^XNA又.
//============================================================================
// AD^XN(又).
void AD_main() {
	int i;
	ushort *dp;
	
	dp = (ushort*)&(ADCA0.DR00.UINT32);
	if (AD_flag != AD_STATUS_IDLE) {
		for (i = 0; i < AD_NUMBER; i++) {
//			if (AD_flag == AD_STATUS_READY) AD_out_data[i] -= AD_in_data[i][AD_cnt];
			AD_out_data[i] -= AD_in_data[i][AD_cnt];		//ړω񐔑Õf[^폜
			AD_in_data[i][AD_cnt] = *dp++;					//XLl̎擾
			AD_out_data[i] += AD_in_data[i][AD_cnt];
		}
	}
	
	ADCA0.SGSTCR1.UINT32 = 1;		//ADCX^[g

	if (AD_flag == AD_STATUS_IDLE) AD_flag = AD_STATUS_BUSY;
	if (++AD_cnt >= AD_AVENUM) {
		AD_cnt = 0;
		AD_flag = AD_STATUS_READY;
	}
	
	delay_task(AD_PERIOD);
}

//============================================================================
// [J֐.
//============================================================================

//============================================================================
// nh.
//============================================================================

//============================================================================
