//============================================================================
// CAN^XN
//
// (c)2023 Maikon-Giken
//============================================================================
#include "kernel.h"
#include "task_can.h"
#include "task_eep_i2c.h"

//---------------------------------------------------------------------
// `.
//---------------------------------------------------------------------
//void CAN_main(void);				// pPbg.

//---------------------------------------------------------------------
// f[^.
//---------------------------------------------------------------------
static	int	flag;				// MǗtO.

//---------------------------------------------------------------------
// hCoAPI
//---------------------------------------------------------------------
// CANhCo.
void CAN_init(void) {
	int i, j;

	//|[gݒ
	CAN0_RX_PIN_PFCAE = 1;		// mode 7i
	CAN0_RX_PIN_PFCE = 1;
	CAN0_RX_PIN_PMC = 1;
	
	CAN0_TX_PIN_PM = 1;			// mode 2o
	CAN0_TX_PIN_PFCAE = 0;
	CAN0_TX_PIN_PFCE = 0;
	CAN0_TX_PIN_PFC	= 1;
	CAN0_TX_PIN = 1;
	CAN0_TX_PIN_PM = 0;
	CAN0_TX_PIN_PMC	= 1;

	CAN1_RX_PIN_PFCAE = 1;		// mode 7i
	CAN1_RX_PIN_PFCE = 1;
	CAN1_RX_PIN_PMC = 1;

	CAN1_TX_PIN_PM = 1;			// mode 4o
	CAN1_TX_PIN_PFCAE = 0;
	CAN1_TX_PIN_PFCE = 1;
	CAN1_TX_PIN_PFC = 1;
	CAN1_TX_PIN = 1;
	CAN1_TX_PIN_PM = 0;
	CAN1_TX_PIN_PMC	= 1;

	//GRAMINIT҂
	while(CAN_GSTS_GRAMINIT) __nop();
	
	//O[oZbgA`lZbg
	CAN_GCTR_GSLPR = 0;
	while(CAN_GSTS_GSLPSTS) __nop();
	CAN0_CTR_CSLPR = 0;
	CAN1_CTR_CSLPR = 0;
	while (CAN0_STS_CSLPSTS || CAN1_STS_CSLPSTS) __nop();
	
	//CAN FD[hݒ(CLOE,FDOE)ftHĝ܂
	
	//O[oRtBOA`lRtBO
#if 1
	CAN_GCFG = 0;				//clkc
//	CAN_GCFG = 0 | (1 << 16);	//clkc | (MԊu > 0)
	if (CAN_FD_BAUDRATE == CAN_BAUDRATE) j = 9;
	else								 j = 0;
	CAN0_NCFG = (1 << 24) | (4 << 16) | (0 << 11) | (9);		//TSEG2=2 | TSEG1=5 | SJW=1 | 10
	CAN0_DCFG = (1 << 24) | (4 << 16) | (0 << 11) | (j);		//TSEG2=2 | TSEG1=5 | SJW=1 | xɂ镪
	CAN1_NCFG = (1 << 24) | (4 << 16) | (0 << 11) | (9);		//TSEG2=2 | TSEG1=5 | SJW=1 | 10
	CAN1_DCFG = (1 << 24) | (4 << 16) | (0 << 11) | (j);		//TSEG2=2 | TSEG1=5 | SJW=1 | xɂ镪
#else
	CAN_GCFG = (1 << 4);				//xinmain
//	CAN_GCFG = (1 << 4) | (1 << 16);	//xinmain | (MԊu > 0)
	CAN0_NCFG = (3 << 24) | (10 << 16) | (3 << 11) | (0);		//TSEG2=4 | TSEG1=11 | SJW=4 | 1	xinmainpݒ
	CAN1_NCFG = (3 << 24) | (10 << 16) | (3 << 11) | (0);		//TSEG2=4 | TSEG1=11 | SJW=4 | 1	xinmainpݒ
#endif

	//M[
	CAN_GAFLCFG = (1 << 24) | (1 << 16);			//[͊e`l1

	CAN_GAFLECTR_AFLDAE = 1;						//[݊Jn
	//M[(ID)
	i = eep_data.para2[EEP_DATA2B_CANID0] & 0x7ff;
	j = eep_data.para2[EEP_DATA2B_CANID1] & 0x7ff;
	if (i == j) j = i + 1;
	CAN0_GAFLID = (0 << 31) | (0 << 30) | (0 << 29) | i;	// Standard ID | Data frame | ȊOCAN ID| ID
	CAN1_GAFLID = (0 << 31) | (0 << 30) | (0 << 29) | j;	// Standard ID | Data frame | ȊOCAN ID| ID
	//M[(}XN)
	CAN0_GAFLM = (1 << 31) | (1 << 30) | 0;	// IDEr | RTRr | IDrȂ
	CAN1_GAFLM = (1 << 31) | (1 << 30) | 0;	// IDEr | RTRr | IDrȂ
	//M[(x)
	CAN0_GAFLP0 = (0 << 16) | (0 << 15) | (0 << 8) | 0;	//x | Mobt@gp | Mobt@ԍ(Ô) | DLC`FbN
	CAN1_GAFLP0 = (0 << 16) | (0 << 15) | (1 << 8) | 0;	//x | Mobt@gp | Mobt@ԍ(Ô) | DLC`FbN
	//M[(FIFOI)
	CAN0_GAFLP1 = (1 << 0);		//MFIFOԍ(rbgʒuԍ)
	CAN1_GAFLP1 = (1 << 1);		//MFIFOԍ(rbgʒuԍ)

	CAN_GAFLECTR_AFLDAE = 0;		//[݊
	
	//Mobt@ݒ͖(ftHĝ܂)
//	CAN_RMNB = 16;
	
	//MFIFOݒ
	CAN0_RFCC = (4 << 8) | (0 << 4) | (0 << 1) | 0;			// 32bZ\W | 8oCg | ݋֎~ | FIFOgpȂ(łɐݒ)
	CAN1_RFCC = (4 << 8) | (0 << 4) | (0 << 1) | 0;			// 32bZ\W | 8oCg | ݋֎~ | FIFOgpȂ(łɐݒ)
	//MFIFOݒ
	CAN0_CFCC = (0 << 24) | (4 << 21) | (1 << 16) | (1 << 8) | (0 << 4) | 0;	// MԊu0 | 32bZ[W | Ή鑗Mobt@ | M[h | 8oCg | FIFOgpȂ(łɐݒ)
	CAN1_CFCC = (0 << 24) | (4 << 21) | (1 << 16) | (1 << 8) | (0 << 4) | 0;	// MԊu0 | 32bZ[W | Ή鑗Mobt@ | M[h | 8oCg | FIFOgpȂ(łɐݒ)
	
	//O[oZbgA`lZbg
	CAN_GCTR = 1;
	CAN0_CTR = 1;
	CAN1_CTR = 1;
	
	//ݐݒ
	NVIC_disable_irq(CAN_GINT_ERR);
	NVIC_clr_irq(CAN_GINT_ERR);
	NVIC_disable_irq(CAN0_INT_ERR);
	NVIC_clr_irq(CAN0_INT_ERR);
	NVIC_disable_irq(CAN1_INT_ERR);
	NVIC_clr_irq(CAN1_INT_ERR);
	
	//O[o샂[hA`lʐM[hJ
	CAN_GCTR &= ~0x03;
	while (CAN_GSTS_GRSTSTS) __nop();
	CAN0_RFCC |= 1;						//FIFO
	CAN1_RFCC |= 1;						//FIFO
	CAN0_CTR &= ~0x03;
	CAN1_CTR &= ~0x03;
	while (CAN0_STS_CRSTSTS || CAN1_STS_CRSTSTS) __nop();
	CAN0_CFCC |= 1;
	CAN1_CFCC |= 1;
	
	//	start_task(CAN_taskid, CAN_main);
}

//---------------------------------------------------------------------
// CANpPbgM.
int	CAN_send(CAN_PACKET *pp) {
	int		ret = EOF, j;
	uchar *q;
	
	if 	(pp->port == 0) {		// ch0M
#if 0
		//Mobt@gp
		if (CAN0_TMSTS & 1) return ret;
		ret = 0;
		CAN0_TMSTS = 0;
		CAN0_TMID = pp->id & 0x7ff;
		CAN0_TMPTR = pp->dlc << 28;
		if (CAN_FD_BAUDRATE == CAN_BAUDRATE)	j = 0;
		else									j = 1;
		CAN0_TMFDCTR = (1 << 2) | (j << 1);
		q = (uchar *)&(CAN0_TMDF0(LL));
		for (j = 0; j < pp->dlc; j++) *q++ = pp->data[j];
		CAN0_TMC = 1;
#else
		//MFIFOgp
		if (CAN0_CFSTS_CFFLL) return ret;
		ret = CAN_SEND_SIZE - CAN0_CFSTS_CFMC - 1;
		if (ret < 0) ret = 0;
		CAN0_CFID = pp->id;
		CAN0_CFPTR = pp->dlc << 28;
		if (CAN_FD_BAUDRATE == CAN_BAUDRATE)	j = 0;
		else									j = 1;
		CAN0_CFFDC = (1 << 2) | (j << 1);
		q = (uchar *)&(CAN0_CFDF0(LL));
		for (j = 0; j < pp->dlc; j++) *q++ = pp->data[j];
		CAN0_CFPCTR = 0xff;
#endif
	}
	else {						// ch1M
#if 0
		//Mobt@gp
		if (CAN1_TMSTS & 1) return ret;
		ret = 0;
		CAN1_TMSTS = 0;
		CAN1_TMID = pp->id & 0x7ff;
		CAN1_TMPTR = pp->dlc << 28;
		if (CAN_FD_BAUDRATE == CAN_BAUDRATE)	j = 0;
		else									j = 1;
		CAN1_TMFDCTR = (1 << 2) | (j << 1);
		q = (uchar *)&(CAN1_TMDF0(LL));
		for (j = 0; j < pp->dlc; j++) *q++ = pp->data[j];
		CAN1_TMC = 1;
#else
		//MFIFOgp
		if (CAN1_CFSTS_CFFLL) return ret;
		ret = CAN_SEND_SIZE - CAN1_CFSTS_CFMC - 1;
		if (ret < 0) ret = 0;
		CAN1_CFID = pp->id;
		CAN1_CFPTR = pp->dlc << 28;
		if (CAN_FD_BAUDRATE == CAN_BAUDRATE)	j = 0;
		else									j = 1;
		CAN1_CFFDC = (1 << 2) | (j << 1);
		q = (uchar *)&(CAN1_CFDF0(LL));
		for (j = 0; j < pp->dlc; j++) *q++ = pp->data[j];
		CAN1_CFPCTR = 0xff;
#endif
	}

	return ret;
}

//---------------------------------------------------------------------
// CANpPbgM.
int CAN_receive(CAN_PACKET *pp) {
	int		ret, n, j;
	uchar	*q;
	
	for (n = 0; n < 2; n++) {
		if (flag == 0) {
			flag ^= 1;
			ret = CAN0_RFSTS_RFMC - 1;
			if (ret >= 0) {
				if (ret < 0) ret = 0;
				pp->port = 0;
				pp->id = CAN0_RFID;
				pp->dlc = CAN0_RFDLC;
				q = (uchar *)&(CAN0_RFDF0(LL));
				for (j = 0; j < 8; j++) {
					if (j < pp->dlc)	pp->data[j] = *q++;
					else				pp->data[j] = 0;
				}
				CAN0_RFPCTR = 0xff;
				ret += CAN1_RFSTS_RFMC;
				return ret;
			}
		}
		else {
			flag ^= 1;
			ret = CAN1_RFSTS_RFMC - 1;
			if (ret >= 0) {
				if (ret < 0) ret = 0;
				pp->port = 1;
				pp->id = CAN1_RFID;
				pp->dlc = CAN1_RFDLC;
				q = (uchar *)&(CAN1_RFDF0(LL));
				for (j = 0; j < 8; j++) {
					if (j < pp->dlc)	pp->data[j] = *q++;
					else				pp->data[j] = 0;
				}
				CAN1_RFPCTR = 0xff;
				ret += CAN0_RFSTS_RFMC;
				return ret;
			}
		}
	}
	
	return EOF;
}

//---------------------------------------------------------------------
// hCo^XN.
//---------------------------------------------------------------------
#if 0
void CAN_main(void) {				// pPbg.
    sleep_task();
}
#endif

//---------------------------------------------------------------------
// 荞݊֐.
//---------------------------------------------------------------------

//============================================================================
