//============================================================================
// LCDpwb_
//
// (c)2023 Maikon-Giken
//============================================================================
#ifndef TASK_LCD_H
#define TASK_LCD_H

#include <stdio.h>

//============================================================================
// `.
//============================================================================
#define LCD_BUFF_SIZE		256			// \obt@TCY.

#if TARGET_LCD == LCD_TYPE_SG12864
#define LCD_H_MAX			16			// LCD.
#define LCD_V_MAX			4			// LCDs.
#endif
#if TARGET_LCD == LCD_TYPE_AQM1248
#define LCD_H_MAX			16			// LCD.
#define LCD_V_MAX			3			// LCDs.
#endif
/*
 * R[hꗗ
 * \b(\x08)		obNXy[X(p1ޖ)
 * \t(\x09)		^u(p4Pʂ̈ʒu܂ŃNAăJ[\ړ)
 * \n(\x0a)		s(J[\ʒuE[܂łNAĂ,̍s̐擪ɃJ[\ړ)
 * \x16			o[Xoff(ʏ\ɖ߂)
 * \x17			o[Xon(ȍ~̕\])
 * \x18\xPP\xQQ	J[\ʒuړB
 *				PP(bit7-2):sʒu(Έʒu0..31܂͑Έʒu-32..+31)
 *				PP(bit1)  :'0'ȂΈʒu, '1'Ȃ瑊ΈʒuB
 *				PP(bit0)  :'1'wB
 *				QQ(bit7-1):ʒu(Έʒu0..63܂͑Έʒu-64..+63)
 *				QQ(bit0)  :'1'wB
 * \x19			gp֎~(J[\ʒuړ̓p)
 */

 //============================================================================
// API֐.
//============================================================================
// LCDI[v֐
FILE* LCD_open(const char *name, const char *mode);

//----------------------------------------------------------------------------
// LCDN[Y֐
int LCD_close(void *fp);

//----------------------------------------------------------------------------
// LCDhCoE^XN.
void LCD_init();

//============================================================================
#endif	/* TASK_LCD_H */
