//============================================================================
// PWMo͗phCo
//
// (c)2023 Maikon-Giken
//============================================================================
#include "kernel.h"
#include "task_pwm.h"

//============================================================================
// `.
//============================================================================

//============================================================================
// vg^Cv.
//============================================================================

//============================================================================
// f[^.
//============================================================================
static int		count_max;


//============================================================================
// API֐.
//============================================================================
// PWMhCo.
void PWM_init(void) {
	//^C}[hݒ
	PWM_MAST_CMOR = (2 << 14) |		// CK2=20MHzI
					(1 << 11) ;		// }X^@\
	PWM_SLAV_CMOR =	(2 << 14) |		// CK2I
					(4 << 8)  |		// X[ugK
					(4 << 1)  |		// JEg[hݒ
					(1)		  ;		// 쒆gKL

}

//----------------------------------------------------------------------------
// PWMݒ.
int PWM_start(int freq, int nega) {
	
	count_max = PWM_FREQUENCY / freq;
	if (count_max > 65535) count_max = 65535;
	PWM_MAST_CDR = count_max - 1;				//ݒ.
	PWM_SLAV_CDR = 0;							//0%.
	
	PWM_SLAV_TOE = 1;							//o̓Cl[u
	PWM_SLAV_TOM = 1;							//o̓[h
	if (nega < 0)	PWM_SLAV_TOL = 1;			//o͕_
	else			PWM_SLAV_TOL = 0;			//o͐_
	
	PWM_PIN_PMC = 1;							//o̓sݒ
	PWM_PIN_PM  = 0;
	
	PWM_MAST_ST |= PWM_MAST_CH_BIT;				//Jn
	return count_max;
}

//----------------------------------------------------------------------------
// PWMo(JE^lڎw).
void PWM_out(int count) {
	if (count > count_max) count = count_max;
	if (count < 0) count = 0;
	PWM_SLAV_CDR = count;
}

//----------------------------------------------------------------------------
// PWMo(䗦w).
void PWM_ratio(float r) {
	PWM_out((int)(r * count_max + 0.5));
}

//============================================================================
// ^XNA又.
//============================================================================

//============================================================================
// [J֐.
//============================================================================

//============================================================================
// nh.
//============================================================================

//============================================================================
